/* 
 *  GGI/DM stubs
 *
 *  Copyright (c) 1999 Nicolai Haehnle - Locinga@pfaffenwinkel.de
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#define DEBUG		1

#include <ggi/internal/dm_int.h>


int ggiDMSetMode(ggi_visual_t vis, int sizex, int sizey, int frames,
		 ggi_graphtype type)
{
	return LIBGGI_DMEXT(vis)->setmode(vis,sizex,sizey,frames,type);
}

ggidm_drawmap ggiDMAddDrawmap(ggi_visual_t vis, int sizex, int sizey, 
			      int flags)
{
	return LIBGGI_DMEXT(vis)->adddrawmap(vis,sizex,sizey,flags);
}

int ggiDMFlip(ggi_visual_t vis)
{ 
	dmext *hook = LIBGGI_DMEXT(vis);
	if (hook->flags & GGIFLAG_ASYNC)
		ggiFlush(vis);
	return hook->flip(vis);
}

int ggiDMFlush(ggidm_drawmap dm)
{
	if (!(dm->parent->flags & GGIDM_VISIBLE))
		return ggiFlushRegion(dm->vis, dm->pos.x, dm->pos.y,
			dm->size.x, dm->size.y);
	return dm->hook->old_flush(dm->vis, dm->pos.x, dm->pos.y,
			dm->size.x, dm->size.y, 1);
}

int ggiDMCloseDrawmap(ggidm_drawmap dm)
{ 
	return LIBGGI_DMEXT(dm->vis)->closedrawmap(dm);
}

int ggiDMAcquired(ggidm_drawmap dm)
{
	return (dm->flags & GGIDM_ACQUIRED);
}

int ggiDMAcquire(ggidm_drawmap dm, int acquire)
{ 
	return LIBGGI_DMEXT(dm->vis)->acquire(dm,acquire);
}

ggi_visual_t ggiDMGetVisual(ggidm_drawmap dm)
{
	return dm->hook->getvisual(dm);
}

